/**
 * copyright area
 */
package org.objectweb.speedo.generation.api;

import org.objectweb.util.monolog.api.LoggerFactory;
import org.objectweb.speedo.metadata.SpeedoXMLDescriptor;
import org.objectweb.speedo.naming.lib.NamingManagerFactory;
import org.objectweb.jorm.metainfo.api.Manager;
import org.apache.tools.ant.types.Path;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Properties;
import java.util.Map;
import java.io.IOException;
import java.io.FileInputStream;

/**
 * @author S.Chassande-Barrioz
 */
public class SpeedoCompilerParameter {

    /*
* the configuration files
*/
    public String logPropFile = null;

    public LoggerFactory loggerFactory = null;

    /*
* Fields for JORM Generation
*/
    public String confFile = null;
    public boolean localpropertiesfile = false;
    public String projectName = "";
    public String mapperName = null;

    public boolean keepsrc = true;
    public boolean failsonerror = true;
    public boolean keepclasses = false;
    public String output;
    public String input;
    public Collection jormclasspath = null;
    public Path speedoclasspath = null;
    public boolean generateNeededJormFile = true;


    /**
     * This fields is used by the Speedo to reference the SpeedoXMLDescriptor.
     * This field is filled by the JDOParser.
     */
    public Map xmldescriptor = null;

    /**
     * the classpath to compile. must include Jorm, Speedo, user classes.
     */
    public Path classpath = null;
    public Collection jdo = null;
    public String jdoDir = null;
    public Collection jorm = null;
    public String jormDir = null;
    public Collection awareFiles = null;
    public String awareFilesDir = null;
    public ArrayList dtdLocations = new ArrayList();

    public NamingManagerFactory nmf = new NamingManagerFactory();

    public void loadConfigFile() throws IOException {
        if (confFile == null)
            return;
        Properties p = new Properties();
        p.load(new FileInputStream(confFile));
        String v = null;
        if ((v = p.getProperty("org.objectweb.speedo.mapperName", null)) != null)
            mapperName = v;
    }

}
