/**
 * Copyright (C) 2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.runtime.genclass.collection;

import org.objectweb.speedo.api.SpeedoAccessor;
import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.naming.api.PName;

import java.util.List;
import java.util.Collection;
import java.util.Iterator;
import java.util.ListIterator;
import java.util.ArrayList;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class ListImpl extends CollectionImpl implements List {


    /**
     * Instantiates a new collection.
     */
    public ListImpl() {
		super();
    }

    // IMPLEMENTATION OF THE GenClass ABSTRACT CLASS //
    //-----------------------------------------------//

    protected SpeedoAccessor createAccessor() {
        return new ListAccessor(this);
    }

    public Object createGenClass() {
        return new ArrayList();
    }

    // IMPLEMENTATION OF THE List INTERFACE //
    //--------------------------------------//

    public boolean addAll(int i, Collection collection) {
        if (collection == null) {
            return true;
        }
        int idx = i;
        Iterator it = collection.iterator();
        while(it.hasNext()) {
            add(idx, it.next());
            idx ++;
        }
        return idx > i;
    }

    public Object get(int i) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).get(i);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoReadIntention(la);
            return la.get(i);
        }
    }

    public Object set(int i, Object o) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).set(i,o);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            return la.set(i, o);
        }
    }

    public void add(int i, Object o) {
        if (!jdoIsActive) {
            ((List) accessor.collection).add(i, o);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            la.add(i, o);
        }
    }

    public Object remove(int i) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).remove(i);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            return la.remove(i);
        }
    }

    public int indexOf(Object o) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).indexOf(o);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoReadIntention(la);
            return la.indexOf(o);
        }
    }

    public int lastIndexOf(Object o) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).lastIndexOf(o);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoReadIntention(la);
            return la.lastIndexOf(o);
        }
    }

    public ListIterator listIterator() {
        if (!jdoIsActive) {
            return ((List) accessor.collection).listIterator();
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            return la.listIterator();
        }
    }

    public ListIterator listIterator(int i) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).listIterator(i);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            return la.listIterator(i);
        }
    }

    public List subList(int i, int i1) {
        if (!jdoIsActive) {
            return ((List) accessor.collection).subList(i, i1);
        } else {
            ListAccessor la = (ListAccessor) getSpeedoAccessor();
            jdoWriteIntention(la);
            return la.subList(i, i1);
        }
    }

}
