/**
 * copyright area
 */
package org.objectweb.speedo.runtime.genclass.map;

import org.objectweb.speedo.runtime.genclass.GenClass;
import org.objectweb.speedo.runtime.genclass.GenClassAccessor;
import org.objectweb.speedo.runtime.genclass.collection.CollectionAccessor;
import org.objectweb.speedo.api.SpeedoAccessor;
import org.objectweb.speedo.api.ProxyManager;
import org.objectweb.jorm.type.api.PType;
import org.objectweb.jorm.naming.api.PName;

import java.util.Map;
import java.util.Collection;
import java.util.Set;
import java.util.HashMap;

public class MapImpl extends GenClass implements Map {

    /**
     * Instantiates a new map.
     */
    public MapImpl() {
        super();
		accessor = (MapAccessor) createAccessor();
    }

    // ------------------------------------------------------------------------
    // IMPLEMENTATION OF THE Collection INTERFACE
    // ------------------------------------------------------------------------

    public int size() {
        if (!jdoIsActive) {
            return accessor.size();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.size();
        }
    }

    public boolean isEmpty() {
        if (!jdoIsActive) {
            return accessor.isEmpty();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.isEmpty();
        }
    }

    public boolean containsKey(Object key) {
        if (!jdoIsActive) {
            return accessor.containsKey(key);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.containsKey(key);
        }
    }

    public boolean containsValue(Object value) {
        if (!jdoIsActive) {
            return accessor.containsValue(value);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.containsValue(value);
        }
    }

    public Object get(Object key) {
        if (!jdoIsActive) {
            return accessor.get(key);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.get(key);
        }
    }

    public Object put(Object key, Object value) {
        if (!jdoIsActive) {
            return accessor.put(key, value);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoWriteIntention(ca);
            return ca.put(key, value);
        }
    }

    public Object remove(Object key) {
        if (!jdoIsActive) {
            return accessor.remove(key);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoWriteIntention(ca);
            return ca.remove(key);
        }
    }

    public void putAll(Map t) {
        if (!jdoIsActive) {
            accessor.putAll(t);
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoWriteIntention(ca);
            ca.putAll(t);
        }
    }

    public void clear() {
        if (!jdoIsActive) {
            accessor.clear();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoWriteIntention(ca);
            ca.clear();
        }
    }

    public Set keySet() {
        if (!jdoIsActive) {
            return accessor.keySet();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.keySet();
        }
    }

    public Collection values() {
        if (!jdoIsActive) {
            return accessor.values();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.values();
        }
    }

    public Set entrySet() {
        if (!jdoIsActive) {
            return accessor.entrySet();
        } else {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoReadIntention(ca);
            return ca.entrySet();
        }
    }

    // IMPLEMENTATION OF THE SpeedoProxy INTERFACE //
    //---------------------------------------------//

    public void setGCValue(Object o) {
        if (jdoIsActive) {
            MapAccessor ca = (MapAccessor) getSpeedoAccessor();
            jdoWriteIntention(ca);
            ca.clear();
            if (o != null) {
                ca.putAll(((Map) o));
            }
        } else {
            accessor.clear();
            if (o != null) {
                accessor.putAll(((Map) o));
            }
        }
    }

	MapAccessor accessor;

	public GenClassAccessor getMainAccessor() {
		return accessor;
	}
    protected SpeedoAccessor createAccessor() {
        return new MapAccessor(this);
    }

    public void jdoMakePersistent(ProxyManager pm) {
        if (size() > 0) {
            jdoMakePersistent(pm, values().iterator());
        }
        if (getInner() != null) {
            jdoMakePersistent(pm, ((Map) getInner()).values().iterator());
        }
    }

    public Object createGenClass() {
        return new HashMap();
    }
}
