/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.bank.client;

import org.objectweb.speedo.bank.common.BankMessage;
import org.objectweb.speedo.bank.common.BankMessageOperation;
import org.objectweb.util.monolog.api.BasicLevel;

import javax.jms.JMSException;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class TestMdb1 extends TestMdb {

	public TestMdb1(String s) {
		super(s);
	}

	protected String getLoggerName() {
		return TestMdb1.class.getName();
	}

	protected String getTopicName() {
		return "SpeedoBankMdb1Topic";
	}

	public void testA() throws JMSException {
		BankMessage bm = new BankMessage();
		bm.operations.add(new BankMessageOperation(BankMessage.OP_CREATE_BANK));
		for (int i = 0; i < 4; i++) {
			bm.operations.add(new BankMessageOperation(
					BankMessage.OP_CREATE_CLIENT, "ln" + i, "fn" + i, "ad" + i));
			bm.operations.add(new BankMessageOperation(BankMessage.OP_CREATE_ACCOUNT));
			bm.operations.add(new BankMessageOperation(
					BankMessage.OP_CREDIT_ACCOUNT, (double) ((i + 1) * 100)));
			bm.operations.add(new BankMessageOperation(BankMessage.OP_ACCOUNT_POP));
			bm.operations.add(new BankMessageOperation(BankMessage.OP_CLIENT_POP));
		}
		sendMessage(bm);
	}
}
