/**
 * Copyright (C) 2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.bank.client;

import org.objectweb.speedo.bank.server.session.BankApplicationHome;
import org.objectweb.speedo.bank.server.BankService;

import javax.naming.NamingException;
import javax.ejb.CreateException;
import java.rmi.RemoteException;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class TestSession1 extends TestSession {

	final static String[][] values = new String[][]{
		{"Chassande-Barrioz", "Sebastien", "Gieres"},
		{"Dechamboux", "Pascal", "Saint Ismier"},
		{"Lefebvre", "Alexandre", "Grenoble"}
	};

	public TestSession1(String arg0) {
		super(arg0);
	}

	protected String getLoggerName() {
		return "org.objectweb.speedo.bank.TestSession1";
	}

	public void testA() throws RemoteException, NamingException, CreateException {
		BankApplicationHome home = lookupBankApplicationHome();
		BankService bankService = home.create();
		System.out.println("Bank " + (bankService.createBank() ? "created" : "loaded"));
		try {
			for (int i = 0; i < values.length; i++) {
				long cid = bankService.createClient(
						values[i][0], values[i][1], values[i][2]);
				System.out.println("Client (LastName=" + values[i][0]
						+ ", FirstName=" + values[i][1]
						+ ", Address=" + values[i][2]
						+ ", id=" + cid + ") created");
				long number = bankService.createAccount(cid);
				System.out.println("\tAccount '" + number + "' created");
			}
			printBank(bankService);
		} catch (Exception e) {
			System.err.println(e.getMessage());
			e.printStackTrace(System.err);
		}
	}
}
