/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.bank.common;

import java.io.Serializable;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class BankMessageOperation implements Serializable {
	public byte operation;
	public String lastName;
	public String firstName;
	public String address;
	public double value;

	public BankMessageOperation(byte operation,
								String lastName,
								String firstName,
								String address) {
		this.operation = operation;
		this.lastName = lastName;
		this.firstName = firstName;
		this.address = address;
	}

	public BankMessageOperation(byte operation) {
		this.operation = operation;
	}

	public BankMessageOperation(byte operation, double value) {
		this.operation = operation;
		this.value = value;
	}

	public String toString() {
		return super.toString()
				+ " / Operation=" + BankMessage.op2Name(operation)
				+ (lastName == null ? "" : " / lastName=" + lastName)
				+ (firstName == null ? "" : " / firstName=" + firstName)
				+ (address == null ? "" : " / address=" + address)
				+ (value == 0 ? "" : " / double=" + value);
	}
}
