/**
 * Copyright (C) 2001-2003 France Telecom R&D
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package org.objectweb.speedo.bank.server.jdo;

import org.objectweb.speedo.bank.server.jdo.Bank;
import org.objectweb.util.monolog.api.BasicLevel;

import java.util.Collection;
import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author S.Chassande-Barrioz
 */
public class Client {

	protected long id; //identifier auto incremented by the database

	protected String lastName;
	protected String firstName;
	protected String address;

	protected Bank bank;
	protected Collection accounts;

	public Client() {
	}

	public Client(long id) {
		this.id = id;
		accounts = new ArrayList();
	}

	public Client(String firstName, String lastName, String address, Bank bank) {
		Log.logger.log(BasicLevel.DEBUG, "Client(" + lastName + ", "
				+ firstName + ", " + address + ")");
		this.lastName = lastName;
		this.firstName = firstName;
		this.address = address;
		this.accounts = new ArrayList();
		bank.clients.add(this);
	}
}
