package org.objectweb.speedo.bank.server.session;

import org.objectweb.speedo.bank.server.BankService;
import org.objectweb.speedo.bank.server.jdo.Bank;
import org.objectweb.speedo.bank.server.jdo.Client;
import org.objectweb.speedo.bank.server.jdo.Account;
import org.objectweb.speedo.bank.common.AccountInfo;
import org.objectweb.speedo.bank.server.jdo.BankServiceImpl;

import javax.ejb.SessionBean;
import javax.ejb.SessionContext;
import javax.ejb.EJBException;
import javax.jdo.PersistenceManagerFactory;
import javax.jdo.PersistenceManager;
import javax.jdo.Query;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import java.rmi.RemoteException;
import java.util.List;
import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;

/**
 * @author S.Chassande-Barrioz
 */
public class BankApplicationImpl
		extends BankServiceImpl
		implements SessionBean, BankService {

	private static final String PMF_CTX_NAME = "java:comp/env/jdo/pmf";

    // IMPLEMENTATION OF THE SessionBean INTERFACE //
    //---------------------------------------------//

    public void setSessionContext(SessionContext sessionContext) throws EJBException, RemoteException {
        if (pmf == null) {
            synchronized (BankServiceImpl.class) {
                if (pmf == null) {
                    try {
                        pmf = (PersistenceManagerFactory)
                            new InitialContext().lookup(PMF_CTX_NAME);
                    } catch (NamingException e) {
                        throw new EJBException("No PersistenceMangerFactory registered"
                            + " in JNDI with the name '" + PMF_CTX_NAME + "'");
                    }
                }
            }
        }
    }

    public void ejbCreate() throws RemoteException {
		bank = null;
    }

    public void ejbRemove() throws EJBException, RemoteException {
		bank = null;
    }

    public void ejbActivate() throws EJBException, RemoteException {
    }

    public void ejbPassivate() throws EJBException, RemoteException {
		bank = null;
    }
}
