/**
 * copyright area
 */
package org.objectweb.speedo.runtime.map;

import org.objectweb.speedo.SpeedoTestHelper;
import org.objectweb.speedo.pobjects.map.Registry;

import javax.jdo.PersistenceManager;

import junit.framework.Assert;

public class TestMap extends SpeedoTestHelper {

    public TestMap(String s) {
        super(s);
    }

    protected String getLoggerName() {
        return LOG_NAME + ".rt.map.TestMap";
    }

    public void testCreation1() {
        Registry r1 = new Registry("r1");
        Registry r2 = new Registry("r2");
        Registry r3 = new Registry("r3");
        r1.bind("a", r2);
        r1.bind("b", r3);

        PersistenceManager pm = pmf.getPersistenceManager();
        pm.makePersistent(r1);
        Object oid1 = pm.getObjectId(r1);
        Assert.assertNotNull("null object identifier of r1", r1);
        pm.close();

        r1 = null;
        r2 = null;
        r3 = null;
        pm = pmf.getPersistenceManager();
        r1 = (Registry) pm.getObjectById(oid1, true);
        Assert.assertNotNull("null instance returned by getObjectById(oid1)", r1);
        r2 = (Registry) r1.lookup("a");
        Assert.assertNotNull("null instance returned by r1.lookup(a)", r2);
        r3 = (Registry) r1.lookup("b");
        Assert.assertNotNull("null instance returned by r1.lookup(b)", r3);
        pm.deletePersistent(r1);
        pm.deletePersistent(r2);
        pm.deletePersistent(r3);
        pm.close();
    }
}
