/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck;

import java.util.Collection;
import java.util.Iterator;
import javax.jdo.PersistenceManagerFactory;

public class GetSupportedOptions {

	public static void main(String[] args) throws Exception {
		if (args.length == 0) {
			System.err.println("Must pass name of PMF as an argument");
			System.exit(-1);
		}
		String PMFclassname = args[0];
		Class PMFclass = Class.forName(PMFclassname);
		PersistenceManagerFactory pmf = (PersistenceManagerFactory) PMFclass.newInstance();
		Collection options = pmf.supportedOptions();
		System.out.println("Supported options are:");
		Iterator iter = options.iterator();
		while (iter.hasNext()) {
			String val = (String) iter.next();
			System.out.println(val);
		}
	}

}
