/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.jdohelper;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;


import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Get Persistence Manager For Transien
 *<BR>
 *<B>JavaTest Keywords:</B> jdohelper
 *<BR>
 *<B>Assertion ID:</B> A8.1-2.
 *<BR>
 *<B>Assertion Description: </B>
 The jdohelper.getPersistenceManager method returns null if object is transient
 evaluating to true when == is used.
 *@test
 *@title GetPersistenceManagerForTransient
 *@executeClass com.sun.jdotck.api.jdohelper.GetPersistenceManagerForTransient
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source GetPersistenceManagerForTransient
 *@keywords jdohelper
 */

/*
* Revision History
* ================
* Author         :   	Date   : 	Version
* Azita Kamangar  	9/28/01		 1.0
*/

public class GetPersistenceManagerForTransient extends JDO_Test {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private PersistenceManager pm1;
	private Transaction transaction;
	private JDOHelper hlp;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		GetPersistenceManagerForTransient t = new GetPersistenceManagerForTransient();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	/* test jdohelper.getPersistenceManager(Object transient)
	*/
	Status testGetPersistenceManagerForTransient() {
		try {
			Transaction tx = pm.currentTransaction();
			tx.begin();
			PCPoint p1 = new PCPoint(1, 3);
			tx.commit();
			pm1 = hlp.getPersistenceManager(p1);

			if (pm1 == null)
				return Status.passed("PASSED in testGetPersistenceManagerForTransient()");
			else
				return Status.failed("FAILED in testGetPersistenceManagerForTransient()");
		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in testGetPersistenceManagerForTransient()");
		}

	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		try {

			PersistenceManagerFactory pmf = getPMF();
			pm = pmf.getPersistenceManager();

			testGetPersistenceManagerForTransient();
			Status s1 = this.testGetPersistenceManagerForTransient();
			pm.close();
			if (s1.isPassed())
				return Status.passed("PASSED in GetPersistenceManagerForTransient");
			else
				return Status.failed("FAILED in GetPersistenceManagerForTransient");

		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in GetPersistenceManagerForTransient()");
		}

	}

}
