/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.jdohelper;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;


import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Get Transactional Object Id For Null
 *<BR>
 *<B>JavaTest Keywords:</B> jdohelper
 *<BR>
 *<B>Assertion ID:</B> A8.3-8
 *<BR>
 *<B>Assertion Description: </B>
 The jdohelper.getTransactionalObjectIdForNull  method returns null if Object is null.Evaluating to true when == is used.
 *@test
 *@title Get Transactional Object Id For Null
 *@executeClass com.sun.jdotck.api.jdohelper.GetTransactionalObjectIdForNull
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source GetTransactionalObjectIdForNull.java
 *@keywords jdohelper
 */
/*
* Revision History
* ================
* Author         :   	Date   : 	Version
* Azita Kamangar  	10/1/01		 1.0
*/

public class GetTransactionalObjectIdForNull extends JDO_Test {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private Transaction transaction;
	private JDOHelper jhlpr;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		GetTransactionalObjectIdForNull t = new GetTransactionalObjectIdForNull();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	/* test jdohelper.getTransactionalObjectId(Object pc)
	 *
	*/
	public Status testGetTransactionalObjectIdForNull() {
		try {
			Transaction tx = pm.currentTransaction();
			tx.begin();
			Object p1 = null;
			Object oid = jhlpr.getTransactionalObjectId(p1);
			tx.commit();

			if (oid == null)
				return Status.passed("PASSED in testGetTransactionalObjectIdForNull()");
			else
				return Status.failed("FAILED in testGetTransactionalObjectIdForNull()");
		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in testGetTransactionalObjectIdForNull()");
		}

	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */

	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		try {

			PersistenceManagerFactory pmf = getPMF();
			pm = pmf.getPersistenceManager();

			testGetTransactionalObjectIdForNull();

			Status s1 = this.testGetTransactionalObjectIdForNull();
			pm.close();
			if (s1.isPassed())
				return Status.passed("PASSED in GetTransactionalObjectIdForNull");
			else
				return Status.failed("FAILED in GetObjectIdforNull");


		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in GetTransactionalObjectIdForNull()");
		}

	}

}
