package com.sun.jdotck.api.jdohelper;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;


import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Make Dirty
 *<BR>
 *<B>JavaTest Keywords:</B> jdohelper
 *<BR>
 *<B>Assertion ID:</B> A8.2-1
 *<BR>
 *<B>Assertion Description: </B>
 The jdohelper.makeDirty method delegates to the parameter instance
 and marks the specified field  dirty if parameter is instance of Persistence
 capable .  evaluating to true when == is used.
 *@test
 *@title Make Dirty
 *@executeClass com.sun.jdotck.api.jdohelper.MakeDirty
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source MakeDirty.java
 *@keywords jdohelper
 */

/*
 * Revision History
 * ================
 * Author         :   	Date   : 	Version
 * Azita Kamangar  	10/2/01		 1.0
 */
public class MakeDirty extends JDO_Test {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private Transaction transaction;
	private JDOHelper jhlpr;
	private boolean flag;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		MakeDirty t = new MakeDirty();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	/* test JDOHelper.MakeDirty(Object pc)
	 *
	*/
	Status testMakeDirty() {
		try {

			Transaction tx = pm.currentTransaction();
			tx.begin();
			PCPoint p1 = new PCPoint(1, 3);
			pm.makePersistent(p1);
			//out.println (" isDirty1:"+ jhlpr.isDirty(p1));
			tx.commit();
			// out.println (" isDirty2:" + jhlpr.isDirty(p1));

			Transaction tx1 = pm.currentTransaction();
			tx1.begin();
			jhlpr.makeDirty(p1, "x");
			flag = jhlpr.isDirty(p1);
			tx1.commit();
			//out.println (" isDirty3:" + flag);
			if (flag == true)

				return Status.passed("PASSED in testMakeDirty()");
			else
				return Status.failed("FAILED in testMakeDirty()");
		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in testMakeDirty()");
		}

	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		try {

			PersistenceManagerFactory pmf = getPMF();
			pm = pmf.getPersistenceManager();
			testMakeDirty();
			Status s1 = this.testMakeDirty();
			pm.close();
			if (s1.isPassed())
				return Status.passed("PASSED in MakeDirty");
			else
				return Status.failed("FAILED in MakeDirty");

		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in MakeDirty()");
		}

	}

}
