/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.jdohelper;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;


import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Make Dirty For Transient
 *<BR>
 *<B>JavaTest Keywords:</B> jdohelper
 *<BR>
 *<B>Assertion ID:</B> A8.2-2
 *<BR>
 *<B>Assertion Description: </B>
 The JDOHelper.makeDirty method has no affect if the instance is transient,
 evaluating to true when == is used.
 *@test
 *@title  Make Dirty For Transient
 *@executeClass com.sun.jdotck.api.jdohelper.MakeDirtyForTransient
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source MakeDirtyForTransient.java
 *@keywords jdohelper
 */

/*
 * Revision History
 * ================
 * Author         :   	Date   : 	Version
 * Azita Kamangar  	10/3/01		 1.0
 */

public class MakeDirtyForTransient extends JDO_Test {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private Transaction transaction;
	private JDOHelper jhlpr;
	private boolean flag;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		MakeDirtyForTransient t = new MakeDirtyForTransient();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	/* test JDOHelper.makeDirthy(Object pc)
	 *
	*/
	Status testMakeDirtyForTransient() {
		try {

			Transaction tx = pm.currentTransaction();
			tx.begin();
			PCPoint p1 = new PCPoint(1, 2);
			out.println(" isDirty1:" + jhlpr.isDirty(p1));


			jhlpr.makeDirty(p1, "x");
			out.println(" isDirty2:" + jhlpr.isDirty(p1));
			flag = jhlpr.isDirty(p1);
			tx.commit();
			if (flag == false)

				return Status.passed("PASSED in testMakeDirtyForTransient()");
			else
				return Status.failed("FAILED in testMakeDirtyForTransient()");
		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in testMakeDirtyForTransient()");
		}

	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */

	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		try {

			PersistenceManagerFactory pmf = getPMF();
			pm = pmf.getPersistenceManager();
			testMakeDirtyForTransient();
			Status s1 = this.testMakeDirtyForTransient();
			pm.close();
			if (s1.isPassed())
				return Status.passed("PASSED in MakeDirtyForTransient");
			else
				return Status.failed("FAILED in MakeDirtyForTransient");

		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("FAILED in MakeDirtyForTransient()");
		}

	}

}
