/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> CurrentTransaction
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion ID:</B> A12.5.2-1
 *<BR>
 *<B>Assertion Description: </B>
 The PersistenceManager.currentTransaction method returns the
 Transaction instance associated with the PersistenceManager.

 *@test
 *@title CurrentTransaction
 *@executeClass com.sun.jdotck.api.persistencemanager.CurrentTransaction
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source CurrentTransaction.java
 *@keywords
 */

public class CurrentTransaction extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;


	public static void main(String[] args) {

		CurrentTransaction t = new CurrentTransaction();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testCurrentTransaction();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in CurrentTransaction tests ");
		} else {
			return Status.failed("FAILED in CurrentTransaction: number of errors detected is " + errCnt);
		}

	}


	public void testCurrentTransaction() {

		try {

			PCPoint p1 = new PCPoint();

			Transaction tx = pm.currentTransaction();
			tx.begin();
			pm.makePersistent(p1);
			tx.commit();

		} catch (Exception ex) {
			assertUnexpectedException(ex, "testCurrentTransaction()");
		}

	}


}
