/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Get IgnoreCache Value from PersistenceManager
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion ID:</B> A12.5.3-1.
 *<BR>
 *<B>Assertion Description: </B>
 The PersistenceManager.getIgnoreCache method returns the current value of the
 IgnoreCache option.

 *@test
 *@title Get IgnoreCache Value from PersistenceManager
 *@executeClass com.sun.jdotck.api.persistencemanager.GetIgnoreCache
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source GetIgnoreCache.java
 *@keywords
 */

public class GetIgnoreCache extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;


	public static void main(String[] args) {

		GetIgnoreCache t = new GetIgnoreCache();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testGetIgnoreCache();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in GetIgnoreCache tests ");
		} else {
			return Status.failed("FAILED in GetIgnoreCache: number of errors detected is " + errCnt);
		}

	}


	public void testGetIgnoreCache() {

		try {

			PCPoint p1 = new PCPoint();

			Transaction tx = pm.currentTransaction();
			tx.begin();
			pm.setIgnoreCache(true);

			boolean returnValue = pm.getIgnoreCache();

			if (!returnValue)
				incrementErrorCount();
			tx.commit();

		} catch (Exception ex) {
			assertUnexpectedException(ex, "testGetIgnoreCache()");
		}

	}


}
