/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;

/**
 *<B>JavaTest Title:</B> Get ObjectId Class
 *<BR>
 *<B>JavaTest Keywords:</B> identity
 *<BR>
 *<B>Assertion IDs:</B> A12.10-1
 *<BR>
 *<B>Assertion Description: </B>
 The method PersistenceManager.getObjectIdClass returns the class of the
 object id for the given class.
 *@test
 *@title get properties
 *@executeClass com.sun.jdotck.api.persistencemanager.GetObjectIdClass
 *@executeArgs -PMFProperties $PMFProperties

 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection

 *@source GetObjectIdClass.java
 *@keywords identity cache
 */


public class GetObjectIdClass extends PersistenceManagerTest {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		GetObjectIdClass t = new GetObjectIdClass();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testGetObjectIdClass();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in GetObjectIdClass tests ");
		} else {
			return Status.failed("FAILED in GetObjectIdClass: number of errors detected is " + errCnt);
		}

	}

	public void testGetObjectIdClass() {

		try {

			Class c1 = pm.getObjectIdClass(PCPoint.class);

			if (c1.getName().equals("com.sun.jdori.fostore.OID")) {
				;
				; // expected result
			} else {
				incrementErrorCount();
			}
		} catch (Exception ex) {
			assertUnexpectedException(ex, "testGetObjectIdClass()");
		}

	}

}
