/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Get PersistenceManagerFactory
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion ID:</B> A12.9-1.
 *<BR>
 *<B>Assertion Description: </B>
 The PersistenceManagerFactory that created a
 PersistenceManager is returned by the method getPersistenceManagerFactory.


 *@test
 *@title Get PersistenceManagerFactory
 *@executeClass com.sun.jdotck.api.persistencemanager.GetPersistenceManagerFactory
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source GetPersistenceManagerFactory.java
 *@keywords
 */

public class GetPersistenceManagerFactory extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;


	public static void main(String[] args) {

		GetPersistenceManagerFactory t = new GetPersistenceManagerFactory();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testGetPersistenceManagerFactory();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in GetPersistenceManagerFactory tests ");
		} else {
			return Status.failed("FAILED in GetPersistenceManagerFactory: number of errors detected is " + errCnt);
		}

	}


	public void testGetPersistenceManagerFactory() {

		try {
			PersistenceManagerFactory pmf2 = pm.getPersistenceManagerFactory();
		} catch (Exception ex) {
			assertUnexpectedException(ex, "testGetPersistenceManagerFactory()");
		}

	}

}
