/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;

/**
 *<B>JavaTest Title:</B> Is Closed Is False Upon Retrieval From a Pool
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion IDs:</B> A12.5-4
 *<BR>
 *<B>Assertion Description: </B>
 The PersistenceManager.isClosed method returns false upon retrieval
 of a PersistenceManager from a pool.
 *@test
 *@title Is Closed Is False Upon Retrieval From a Pool
 *@executeClass com.sun.jdotck.api.persistencemanager.IsClosedIsFalseUponRetrievalFromPool
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source IsClosedIsFalseUponRetrievalFromPool.java
 *@keywords
 */


public class IsClosedIsFalseUponRetrievalFromPool extends PersistenceManagerTest {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		IsClosedIsFalseUponRetrievalFromPool t = new IsClosedIsFalseUponRetrievalFromPool();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);

		testIsClosed();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in IsClosedIsFalseUponRetrievalFromPool tests ");
		} else {
			return Status.failed("FAILED in IsClosedIsFalseUponRetrievalFromPool: number of errors detected is " + errCnt);
		}

	}

	public void testIsClosed() {
		try {

			String sname = "Jojo";
			String spswd = "mypswd";

			pmf = getPMF();
			pm = pmf.getPersistenceManager(sname, spswd);

			if (pm.isClosed())
				incrementErrorCount();
		} catch (Exception ex) {
			assertUnexpectedException(ex, "testIsClosed()");
		}

	}


}
