/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;

/**
 *<B>JavaTest Title:</B> Is Closed Is True After Close
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion IDs:</B> A12.5-5
 *<BR>
 *<B>Assertion Description: </B>
 The PersistenceManager.isClosed method returns true only after the closemethod completes successfully, i.e. the PersistenceManager has been closed. (same as A35-01).
 *@test
 *@title get properties
 *@executeClass com.sun.jdotck.api.persistencemanager.IsClosedIsTrueAfterClose
 *@executeArgs -PMFProperties $PMFProperties

 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection

 *@source IsClosedIsTrueAfterClose.java
 *@keywords
 */


public class IsClosedIsTrueAfterClose extends PersistenceManagerTest {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		IsClosedIsTrueAfterClose t = new IsClosedIsTrueAfterClose();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();
		pm.close();

		if (pm.isClosed()) {
			return Status.passed("PASSED in IsClosedIsTrueAfterClose tests ");
		} else {
			out.println(" PM still is not closed ");
			return Status.failed("FAILED in IsClosedIsTrueAfterClose tests ");
		}

	}

}
