/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;

/**
 *<B>JavaTest Title:</B> One PersistenceManager If Persistent or Transactional
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion ID:</B> A12.5-2.
 *<BR>
 *<B>Assertion Description: </B>
 A JDO Instance is associated with exactly one <code>PersistenceManager</code>
 if the instance is persistent or transactional.
 This is a duplicate test.
 *@test
 *@title One PersistenceManager If Persistent or Transactional
 *@executeClass com.sun.jdotck.api.persistencemanager.OnePersistenceManagerIfPersistentOrTransactional
 *@executeArgs -PMFProperties $PMFProperties
 * -ApplicationIdentity $ApplicationIdentity
 * -Array $Array
 * -ArrayList $ArrayList
 * -ChangeApplicationIdentity $ChangeApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -List $List
 * -Map $Map
 * -NonDurableIdentity $NonDurableIdentity
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -NullCollection $NullCollection
 * -Optimistic $Optimistic
 * -RetainValues $RetainValues
 * -TransientTransactional $TransientTransactional
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 *@source OnePersistenceManagerIfPersistentOrTransactional.java
 *@keywords
 */

public class OnePersistenceManagerIfPersistentOrTransactional extends JDO_Test {

	/**
	 *The <code>main</code> is called when the class
	 *is directly executed from the command line.
	 *@param args The arguments passed to the program.
	 */
	public static void main(String[] args) {
		OnePersistenceManagerIfPersistentOrTransactional t = new OnePersistenceManagerIfPersistentOrTransactional();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {
//      Once method has been implemented, remove next line and
//      remove ", but not implemented yet" from String value argument to Status.passed
		out.println("com.sun.jdotck.api.persistencemanager.OnePersistenceManagerIfPersistentOrTransactional.run duplicate");

		initializeArgs(args, err, out);

//  Add test logic here

		return Status.passed("Assertion A12.5-2 passed");
	}
}
