/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.api.persistencemanager;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> PassingNullToEvictHasNoEffect
 *<BR>
 *<B>JavaTest Keywords:</B>
 *<BR>
 *<B>Assertion IDs:</B> A12.5.7
 *<BR>
 *<B>Assertion Description: </B>
 Passing a null value to PersistenceManager.evict will have no effect. A
 NullPointerException should NOT be thrown.

 *@test
 *@title PassingNullToEvictHasNoEffect
 *@executeClass com.sun.jdotck.api.persistencemanager.PassingNullToEvictHasNoEffect
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection

 *@source PassingNullToEvictHasNoEffect.java
 *@keywords
 */

public class PassingNullToEvictHasNoEffect extends PersistenceManagerTest {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private Transaction tx;


	/* standalone interface */
	public static void main(String[] args) throws Exception {

		PassingNullToEvictHasNoEffect t = new PassingNullToEvictHasNoEffect();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testPassingNullToEvictHasNoEffect();

		pm.close();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PassingNullToEvictHasNoEffect tests passed");
		} else {
			return Status.failed("PassingNullToEvictHasNoEffect: number of errors detected is " + errCnt);
		}

	}


	/* test evict (object pc) */
	public void testPassingNullToEvictHasNoEffect() {
		try {
			tx = pm.currentTransaction();
			tx.begin();
			pm.evict(null);
			out.println(" \nPASSED in testPassingNullToEvictHasNoEffect()");
			tx.rollback();
		} catch (Exception ex) {
			assertUnexpectedException(ex, "testPassingNullToEvictHasNoEffect()");
			tx.rollback();
		}

	}
}
