/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Set Multithreaded False
 *<BR>
 *<B>JavaTest Keywords:</B> multithreaded
 *<BR>
 *<B>Assertion ID:</B> A12.7-2.
 *<BR>
 *<B>Assertion Description: </B>
 If PersistenceManager.setMultithreaded is called with a value of false, a value of false
 will be returned when getMultithreaded is called.

 *@test
 *@title Set Multithreaded False
 *@executeClass com.sun.jdotck.api.persistencemanager.SetMultithreadedFalse
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source SetMultithreadedFalse.java
 *@keywords multithreaded
 */

public class SetMultithreadedFalse extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;


	public static void main(String[] args) {

		SetMultithreadedFalse t = new SetMultithreadedFalse();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testSetMultithreadedFalse();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in SetMultithreadedFalse tests ");
		} else {
			return Status.failed("FAILED in SetMultithreadedFalse: number of errors detected is " + errCnt);
		}

	}


	public void testSetMultithreadedFalse() {

		try {

			PCPoint p1 = new PCPoint();

			Transaction tx = pm.currentTransaction();
			tx.begin();
			pm.setMultithreaded(false);

			boolean returnValue = pm.getMultithreaded();

			if (returnValue)
				incrementErrorCount();
			tx.commit();

		} catch (Exception ex) {
			assertUnexpectedException(ex, "testSetMultithreadedFalse()");
		}

	}


}
