/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Setting Flags With Transaction instance
 *<BR>
 *<B>JavaTest Keywords:
 *<BR>
 *<B>Assertion ID:</B> A12.5.2-3.
 *<BR>
 *<B>Assertion Description: </B>
 Even if the Transaction instance returned by PersistenceManager.currentTransaction
 cannot be used for transaction completion (due to external transaction management), it still can be used to set flags.

 *@test
 *@title Setting Flags With Transaction instance
 *@executeClass com.sun.jdotck.api.persistencemanager.SettingFlagsWithTransactionInstance
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source SettingFlagsWithTransactionInstance.java
 *@keywords
 */

public class SettingFlagsWithTransactionInstance extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;


	public static void main(String[] args) {

		SettingFlagsWithTransactionInstance t = new SettingFlagsWithTransactionInstance();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testSettingFlagsWithTransactionInstance();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in SettingFlagsWithTransactionInstance tests ");
		} else {
			return Status.failed("FAILED in SettingFlagsWithTransactionInstance: number of errors detected is " + errCnt);
		}

	}


	public void testSettingFlagsWithTransactionInstance() {

		try {

			Transaction tx = pm.currentTransaction();
			tx.setNontransactionalRead(false);
			tx.setNontransactionalWrite(false);
			tx.setRetainValues(false);
			tx.setOptimistic(false);
		} catch (Exception ex) {
			assertUnexpectedException(ex, "testSettingFlagsWithTransactionInstance()");
		}

	}


}
