/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanager;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Instance Associated with Zero or One PersistenceManager
 *<BR>
 *<B>JavaTest Keywords: multipleJDOimpls
 *<BR>
 *<B>Assertion ID:</B> A5.2-3.
 *<BR>
 *<B>Assertion Description: </B>
 An instance of an enhanced class must only be associated with zero or one
 PersistenceManager at a time.

 *@test
 *@title Instance Associated with Zero or One PersistenceManager
 *@executeClass com.sun.jdotck.api.persistencemanager.ZeroOrOnePersistenceManager
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source ZeroOrOnePersistenceManager.java
 *@keywords multipleJDOimpls
 */

public class ZeroOrOnePersistenceManager extends PersistenceManagerTest {

	private PersistenceManagerFactory pmf;
	private PersistenceManager pm1;


	public static void main(String[] args) {

		ZeroOrOnePersistenceManager t = new ZeroOrOnePersistenceManager();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	public Status runTest(String[] args, PrintWriter err, PrintWriter out) {


		initializeArgs(args, err, out);
		pmf = getPMF();

		testZeroOrOnePersistenceManager();

		int errCnt = getErrorCount();
		if (errCnt == 0) {
			return Status.passed("PASSED in ZeroOrOnePersistenceManager tests ");
		} else {
			return Status.failed("FAILED in ZeroOrOnePersistenceManager: number of errors detected is " + errCnt);
		}

	}


	public void testZeroOrOnePersistenceManager() {

		try {

			PCPoint p1 = new PCPoint();

			pm1 = pmf.getPersistenceManager();
			Transaction tx = pm1.currentTransaction();
			tx.begin();
			pm1.makePersistent(p1);
			tx.commit();

		} catch (Exception ex) {
			assertUnexpectedException(ex, "ZeroOrOnePersistenceManager()");
		}

	}


}
