/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.api.persistencemanagerfactory;

import java.io.*;
import java.lang.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;

import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B>SupportedOptions of persistencemanagerfactory
 *<BR>
 *<B>JavaTest Keywords:</B> persistencemanagerfactory
 *<BR>
 *<B>Assertion IDs:</B> A11.5-1.
 *<BR>
 *<B>Assertion Description: </B>
 * PersistenceManagerFactory.supportedOptions() returns a Collection
 of String, each String instance representing an optional feature of the
 implementation or a supported query language.
 *@test
 *@title supportedOptions
 *@executeClass com.sun.jdotck.api.persistencemanagerfactory.SupportedOptions
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source SupportedOptions.java
 *@keywords
 */

/*
 * Revision History
 * ================
 * Author         :   Linga Neerathilingam
 * Date   :  10/22/01
 *
 */

public class SupportedOptions extends JDO_Test {
	private PersistenceManagerFactory pmf;

	/* standalone interface */
	public static void main(String[] args) throws Exception {
		SupportedOptions t = new SupportedOptions();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}


	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);

		pmf = getPMF();

		try {
			out.println("Options supported by this implementation:");
			Collection c = pmf.supportedOptions();
			Iterator iter = c.iterator();
			while (iter.hasNext()) {
				String option = (String) iter.next();
				out.println(option);
			}
		} catch (Exception ex) {
			ex.printStackTrace(out);
			return Status.failed("Failed in SupportedOptions()");
		}
		out.flush();

		return Status.passed("\n SupportedOptions passed.");
	}
}
