package com.sun.jdotck.enhancement;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;

import java.io.InputStream;
import java.util.Properties;
import java.util.ArrayList;
import java.util.List;
import java.util.Enumeration;
import java.util.StringTokenizer;

import com.sun.jdori.enhancer.test.AugmentationTest;
import com.sun.jdori.enhancer.meta.EnhancerMetaData;

/**
 *<B>JavaTest Title:</B> Implements PersistenceCapable Added
 *<BR>
 *<B>JavaTest Keywords:</B> enhancement
 *<BR>
 *<B>Assertion ID:</B> A20.3-0.
 *<BR>
 *<B>Assertion Description: </B>
 The Reference Enhancer makes the following change
 to persistence-capable classes:
 it adds <code>&quot;implements javax.jdo.PersistenceCapable</code>&quot;
 to the class definition.

 *@test
 *@title Implements PersistenceCapable Added
 *@executeClass com.sun.jdotck.enhancement.ImplementsPersistenceCapable
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -ChangeApplicationIdentity $ChangeApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source ImplementsPersistenceCapable.java
 *@keywords enhancement
 */

public class ImplementsPersistenceCapable extends EnhancerTest {

	/**
	 *The <code>main</code> is called when the class
	 *is directly executed from the command line.
	 *@param args The arguments passed to the program.
	 */
	public static void main(String[] args) {
		ImplementsPersistenceCapable t = new ImplementsPersistenceCapable();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		t.out.flush();
		t.err.flush();
		System.out.flush();
		System.err.flush();
		s.exit();
	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		out.println("com.sun.jdotck.enhancement.ImplementsPersistenceCapable.run");

		initializeArgs(args, err, out);

		testAllPackages();

		cleanup();

		if (getErrorCount() == 0) {
			return Status.passed("Assertion A20.3-0 passed " + getTestCount() + " tests");
		} else {
			return Status.failed("Assertion A20.3-0 failed, " + getErrorCount() +
					" failed tests out of " + getTestCount());
		}
	}

	protected void testOnePackage(String packageName, List fullyQualifiedClassNames) {
		out.println("ImplementsPersistenceCapable.testOnePackage: " + packageName + fullyQualifiedClassNames);
		out.flush();
		EnhancerMetaData metaData = getEnhancerMetaData(packageName);
		out.println("ImplementPersistenceCapable.testOnePackage got metaData: " + metaData);
		AugmentationTest test = new AugmentationTest(metaData);
		out.println("ImplementPersistenceCapable.testOnePackage got test: " + test);
		incrementErrorCount(test.test(out, verbose, fullyQualifiedClassNames));
	}

	protected String convertClassName(String packageName, String className) {
		return packageName + "." + className;
	}

}
