/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.extents;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;

import com.sun.jdotck.models.company.*;

import javax.jdo.*;

/**
 *<B>JavaTest Title:</B> Has Subclasses is True
 *<BR>
 *<B>JavaTest Keywords:</B> extent inheritance
 *<BR>
 *<B>Assertion ID:</B> A15.3-6.
 *<BR>
 *<B>Assertion Description: </B>
 <code>Extent.hasSubclasses()</code> returns <code>true</code>
 if the extent includes subclasses.

 *@test
 *@title Has Subclasses is True
 *@executeClass com.sun.jdotck.extents.HasSubclassesTrue
 *@executeArgs -PMFProperties $PMFProperties
 * -ApplicationIdentity $ApplicationIdentity
 * -Array $Array
 * -ArrayList $ArrayList
 * -ChangeApplicationIdentity $ChangeApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -List $List
 * -Map $Map
 * -NonDurableIdentity $NonDurableIdentity
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -NullCollection $NullCollection
 * -Optimistic $Optimistic
 * -RetainValues $RetainValues
 * -TransientTransactional $TransientTransactional
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 *@source HasSubclassesTrue.java
 *@keywords extent inheritance
 */

public class HasSubclassesTrue extends ExtentTest {

	/**
	 *The <code>main</code> is called when the class
	 *is directly executed from the command line.
	 *@param args The arguments passed to the program.
	 */
	public static void main(String[] args) {
		HasSubclassesTrue t = new HasSubclassesTrue();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {
//      Once method has been implemented, remove next line and
//      remove ", but not implemented yet" from String value argument to Status.passed

		initializeArgs(args, err, out);

//  Add test logic here

		Extent ex = getPM().getExtent(Employee.class, true);
		if (ex.hasSubclasses())
			return Status.passed("Assertion A15.3-6 passed");
		else
			return Status.failed("Assertion A15.3-6 failed");
	}
}
