/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.extents;

import java.io.PrintWriter;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;

import java.util.Iterator;

import javax.jdo.*;

/**
 *<B>JavaTest Title:</B> Iterators
 *<BR>
 *<B>JavaTest Keywords:</B> extent
 *<BR>
 *<B>Assertion ID:</B> A15.3-1.
 *<BR>
 *<B>Assertion Description: </B>
 <code>Extent.iterator()</code> returns an <code>Iterator</code>
 over all the instances in the <code>Extent</code>.

 *@test
 *@title Iterators
 *@executeClass com.sun.jdotck.extents.Iterators
 *@executeArgs -PMFProperties $PMFProperties
 * -ApplicationIdentity $ApplicationIdentity
 * -Array $Array
 * -ArrayList $ArrayList
 * -ChangeApplicationIdentity $ChangeApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -List $List
 * -Map $Map
 * -NonDurableIdentity $NonDurableIdentity
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -NullCollection $NullCollection
 * -Optimistic $Optimistic
 * -RetainValues $RetainValues
 * -TransientTransactional $TransientTransactional
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 *@source Iterators.java
 *@keywords extent
 */

public class Iterators extends ExtentTest {

	/**
	 *The <code>main</code> is called when the class
	 *is directly executed from the command line.
	 *@param args The arguments passed to the program.
	 */
	public static void main(String[] args) {
		Iterators t = new Iterators();
		Status s = t.run(args, new PrintWriter(System.err), new PrintWriter(System.out));
		s.exit();
	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);

		Extent ex = getExtent();

		int count = 0;
		for (Iterator it = ex.iterator(); it.hasNext(); ++count) {
			Object emp = it.next();
			out.println(emp.toString());
		}
		out.flush();
		err.flush();

		if (count == 2)
			return Status.passed("Assertion A15.3-1 passed");
		else
			return Status.failed("Assertion A15.3-1 failed");
	}
}
