
<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE jdo SYSTEM "jdo.dtd">
<jdo>
    <package name="com.sun.jdotck.models.company">

        <class name="Address" identity-type="nondurable"/>

        <class name="Company" identity-type="nondurable">
            <field name="departments" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Department"/>
            </field>
            <field name="address" embedded="true"/>                
        </class>

        <class name="Department" identity-type="nondurable">
            <field name="employees" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Employee"/>
            </field>
        </class>

        <class name="Employee"
          persistence-capable-superclass="com.sun.jdotck.models.company.Person" identity-type="nondurable">
            <field name="reviewedProjects" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Project"/>
            </field>
            <field name="projects" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Project"/>
            </field>
            <field name="team" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Employee"/>
            </field>
            <field name="hradvisees" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Employee"/>
            </field>
        </class>

        <class name="FullTimeEmployee"
          persistence-capable-superclass="com.sun.jdotck.models.company.Employee"/ identity-type="nondurable">

        <class name="Insurance" identity-type="nondurable"/>

        <class name="PartTimeEmployee"
          persistence-capable-superclass="com.sun.jdotck.models.company.Employee" identity-type="nondurable"/>

        <class name="Person" identity-type="nondurable">
            <field name="address" embedded="true"/>
        </class>

        <class name="Project" identity-type="nondurable">
            <field name="reviewers" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Employee"/>
            </field>
            <field name="members" persistence-modifier="persistent">
                <collection element-type="com.sun.jdotck.models.company.Employee"/>
            </field>
        </class>
    </package>
</jdo>
