# Classnames can have the following attributes: 
#          jdo:{persistent|transactional} 
#          super: <classname> 
#          oid: <classname> 
#          access: {public|protected|package|private} 
# Fieldnames can have the following attributes: 
#          type:<type> 
#          access: {public|protected|package|private} 
#          jdo:{persistent|transactional|transient} 
#          annotation:{key|dfg|mediated} 

com.sun.jdotck.models.company.Address=jdo:persistent
com.sun.jdotck.models.company.Address#addrid=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Address#city=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Address#state=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Address#street=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Address#zipcode=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Company=jdo:persistent
com.sun.jdotck.models.company.Company#address=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Company#departments=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Company#founded=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Company#name=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Department=jdo:persistent
com.sun.jdotck.models.company.Department#deptid=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Department#name=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Department#employees=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Department#company=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Employee=jdo:persistent,super:com.sun.jdotck.models.company.Person
com.sun.jdotck.models.company.Employee#department=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#discriminator=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#hiredate=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#insurance=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#hradvisees=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#hradvisor=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#manager=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#mentor=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#projects=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#protege=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#reviewedProjects=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#team=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Employee#weeklyhours=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.FullTimeEmployee=jdo:persistent,super:com.sun.jdotck.models.company.Employee
com.sun.jdotck.models.company.FullTimeEmployee#salary=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Insurance=jdo:persistent
com.sun.jdotck.models.company.Insurance#insid=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Insurance#carrier=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Insurance#employee=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.PartTimeEmployee=jdo:persistent,super:com.sun.jdotck.models.company.Employee
com.sun.jdotck.models.company.PartTimeEmployee#wage=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Person=jdo:persistent
com.sun.jdotck.models.company.Person#address=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Person#birthdate=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Person#firstname=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Person#lastname=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Person#personid=jdo:persistent,annotation:mediated

com.sun.jdotck.models.company.Project=jdo:persistent
com.sun.jdotck.models.company.Project#budget=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Project#members=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Project#name=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Project#projid=jdo:persistent,annotation:mediated
com.sun.jdotck.models.company.Project#reviewers=jdo:persistent,annotation:mediated
