/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.models.inheritance;

import javax.jdo.*;
import java.util.*;

public class AllPersist4 extends AllPersist3 {
	short shortG;  // not managed
	AllPersist4 fourthObj; // not managed
	int intH; // persistent

	AllPersist4() {
		shortG = -360;
		intH = -6;
	}

	AllPersist4(int intA, double doubleB, int intB, char charC, boolean booleanD,
				float floatE, short shortF, short shortG, int intVal) {
		super(intA, doubleB, intB, charC, booleanD, floatE, shortF);
		this.shortG = shortG;
		intH = intVal;
	}

	static void removeAllInstances(PersistenceManager pm) {
		AllPersist4 a = new AllPersist4(0, 0.0, 0, '0', false, 0.0f, (short) 0, (short) 0, 0);
		pm.makePersistent(a); // guarantee the class is registered; this will be removed
		Extent e = pm.getExtent(com.sun.jdotck.models.inheritance.AllPersist4.class, true);
		Iterator i = e.iterator();
		while (i.hasNext()) {
			pm.deletePersistent(i.next());
		}
	}
}
