/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.models.inheritance;

import java.io.Serializable;

class FieldSameName {
	int n1;  // not managed
	double n2;  // persistent
	int n3; // persistent

	private int keyValue;  // persistent--used as key field in application identity
	static private int nextKeyValue = 1;

	FieldSameName() {
		n1 = -1;
		n2 = 2.0;
		n3 = -5;
	}

	FieldSameName(int intA, double doubleVal, int intB) {
		keyValue = nextKeyValue++;
		n1 = intA;
		n2 = doubleVal;
		n3 = intB;
	}

	void setIntA(int intA) {
		n1 = intA;
	}

	int getIntA() {
		return n1;
	}

	void setDoubleB(double doubleB) {
		n2 = doubleB;
	}

	double getDoubleB() {
		return n2;
	}

	void setIntB(int intB) {
		n3 = intB;
	}

	int getIntB() {
		return n3;
	}

	public static class Id implements Serializable {
		public int keyValue;

		public Id() {
		}

		public Id(int keyValue) {
			this.keyValue = keyValue;
		}

		public Id(String s) {
			try {
				keyValue = Integer.parseInt(s);
			} catch (NumberFormatException e) {
				keyValue = 0;
			}
		}

		public boolean equals(Object obj) {
			if (obj == null || !this.getClass().equals(obj.getClass()))
				return false;
			else
				return keyValue == ((Id) obj).keyValue;
		}

		public int hashCode() {
			return keyValue;
		}

		public String toString() {
			return Integer.toString(keyValue);
		}
	}
}
