/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */


package com.sun.jdotck.models.inheritance;

import java.io.Serializable;

public class TopPersist {  //  persistent
	int intA; // not managed
	double doubleB;  // persistent
	int intB; // persistent

	private int keyValue;  // persistent--used as key field in application identity
	static private int nextKeyValue = 1;

	TopPersist() {
		intA = TestParts.intA_V[0];
		doubleB = TestParts.doubleB_V[0];
		intB = TestParts.intB_V[0];
	}

	TopPersist(int intA, double doubleVal, int intB) {
		keyValue = nextKeyValue++;
		this.intA = intA;
		doubleB = doubleVal;
		this.intB = intB;
	}

	public static class Id implements Serializable {
		public int keyValue;

		public Id() {
		}

		public Id(int keyValue) {
			this.keyValue = keyValue;
		}

		public Id(String s) {
			try {
				keyValue = Integer.parseInt(s);
			} catch (NumberFormatException e) {
				keyValue = 0;
			}
		}

		public boolean equals(Object obj) {
			if (obj == null || !this.getClass().equals(obj.getClass()))
				return false;
			else
				return keyValue == ((Id) obj).keyValue;
		}

		public int hashCode() {
			return keyValue;
		}

		public String toString() {
			return Integer.toString(keyValue);
		}
	}
}
