/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

/*
*  Copyright 2001 Sun Microsystems, Inc. All rights reserved.
*  Use is subject to license terms.
*/

package com.sun.jdotck.models.mylib;

import java.io.Serializable;
import java.util.Date;

/**
 * A simple class with two fields for application identity
 *
 * @author Marina Vatkina
 */
public class PCPoint implements Serializable {


	private static long counter = new Date().getTime();

	private static long newId() {
		synchronized (PCPoint.class) {
			return counter++;
		}
	}

	private long id = newId();
	public int x;
	public Integer y;

	public PCPoint() {
	}

	public PCPoint(int x, int y) {
		this.x = x;
		this.y = new Integer(y);
	}

	public PCPoint(int x, Integer y) {
		this.x = x;
		this.y = y;
	}

	public String toString() {
		String rc = null;
		Object obj = this;
		try {
			rc = obj.getClass().getName();
			//rc = Util.getClassName(this) + name();
		} catch (NullPointerException ex) {
			rc = "NPE getting PCPoint's values";
		}
		return rc;
	}

	public void setX(int x) {
		this.x = x;
	}

	public int getX() {
		return x;
	}

	public void setY(Integer y) {
		this.y = y;
	}

	public Integer getY() {
		return y;
	}

	public String name() {
		return " x: " + getX() + ", y: " + getY().intValue();
	}

	public static class Oid {
		public long id;

		public Oid() {
		}

		public Oid(String s) {
			id = Long.parseLong(s);
		}

		public String toString() {
			return this.getClass().getName() + ": " + id;
		}

		public int hashCode() {
			return (int) id;
		}

		public boolean equals(Object other) {
			if (other != null && (other instanceof Oid)) {
				Oid k = (Oid) other;
				return k.id == this.id;
			}
			return false;
		}

	}
}
