/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

/*
*  Copyright 2001 Sun Microsystems, Inc. All rights reserved.
*  Use is subject to license terms.
*/

package com.sun.jdotck.models.mylib;

import java.util.Date;

/**
 * Test for instances with application identity containing instances of
 * a user-defined class.
 *
 * @author Marina Vatkina
 */
public class PCRect {

	private static long counter = new Date().getTime();

	private static long newId() {
		synchronized (PCRect.class) {
			return counter++;
		}
	}

	public long id = newId();

	public PCPoint upperLeft;
	public PCPoint lowerRight;

	public PCRect() {
	}

	public PCRect(long id, PCPoint ul, PCPoint lr) {
		upperLeft = ul;
		lowerRight = lr;
	}

	public PCPoint getUpperLeft() {
		return upperLeft;
	}

	public PCPoint getLowerRight() {
		return lowerRight;
	}

	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public String toString() {
		String rc = null;
		Object obj = this;
		try {
			//rc = Util.getClassName(this)
			rc = obj.getClass().getName()
					+ " ul: " + getUpperLeft().name()
					+ " lr: " + getLowerRight().name();
		} catch (NullPointerException ex) {
			rc = "NPE getting PCRect's values";
		}
		return rc;
	}

	public static class Oid {
		public long id;

		public Oid() {
		}

		public Oid(String s) {
			id = Long.parseLong(s);
		}

		public String toString() {
			return this.getClass().getName() + ": " + id;
		}

		public int hashCode() {
			return (int) id;
		}

		public boolean equals(Object other) {
			if (other != null && (other instanceof Oid)) {
				Oid k = (Oid) other;
				return k.id == this.id;
			}
			return false;
		}

	}

}
