/*
 * Copyright 2001 Sun Microsystems, Inc. All rights reserved.
 * Use is subject to license terms.
 *
 */

package com.sun.jdotck.transactions;

import java.io.*;

import com.sun.javatest.Test;
import com.sun.javatest.Status;
import com.sun.jdotck.JDO_Test;
import com.sun.jdotck.models.mylib.*;


import java.util.Hashtable;
import java.util.Iterator;

import java.util.*;

import javax.jdo.*;


/**
 *<B>JavaTest Title:</B> Is Active
 *<BR>
 *<B>JavaTest Keywords:</B> transactions
 *<BR>
 *<B>Assertion ID:</B> A13.4.1-2.
 *<BR>
 *<B>Assertion Description: </B>
 The transactions.isActive method tells whether there is an active
 transaction. There will be an active transaction if the begin method
 has been executed but neither commit nor rollback has been executed.
 *@test
 *@title Is Active
 *@executeClass com.sun.jdotck.transactions.IsActive
 *@executeArgs -PMFProperties $PMFProperties
 * -TransientTransactional $TransientTransactional
 * -NontransactionalRead $NontransactionalRead
 * -NontransactionalWrite $NontransactionalWrite
 * -RetainValues $RetainValues
 * -Optimistic $Optimistic
 * -ApplicationIdentity $ApplicationIdentity
 * -DatastoreIdentity $DatastoreIdentity
 * -NonDurableIdentity $NonDurableIdentity
 * -ArrayList $ArrayList
 * -HashMap $HashMap
 * -Hashtable $Hashtable
 * -LinkedList $LinkedList
 * -TreeMap $TreeMap
 * -TreeSet $TreeSet
 * -Vector $Vector
 * -Map $Map
 * -List $List
 * -Array $Array
 * -NullCollection $NullCollection
 *@source IsActive.java
 *@keywords transactions
 */


/*
 * Revision History
 * ================
 * Author         :   	Date   : 	Version
 * Azita Kamangar  	10/09/01	 1.0
 */
public class IsActive extends JDO_Test {
	private PersistenceManagerFactory pmf;
	private PersistenceManager pm;
	private PersistenceManager pm1;
	private Transaction transaction;
	private boolean flag;
	private boolean flag2;

	/* standalone interface */
	public static void main(String[] args) throws Exception {

		IsActive t = new IsActive();

		Status s = t.run(args, new PrintWriter(System.err),
				new PrintWriter(System.out));
		s.exit();
	}

	/* test transactions.isActive()
	 *
	*/
	public void testIsActive() {
		try {

			Transaction tx = pm.currentTransaction();
			tx.begin();
			//PCPoint p1 = new PCPoint(1,3);
			//pm.makePersistent(p1);
			flag = tx.isActive();
			tx.commit();

			if (flag == true) {
				;
			} else {
				incrementErrorCount();
			}

			flag2 = tx.isActive();
			if (flag2 == false) {
				;
			} else {
				incrementErrorCount();
			}

		} catch (Exception ex) {
			ex.printStackTrace(out);
			out.println(" Unexception caught in IsActive");
			incrementErrorCount();

		}

	}

	/**
	 *The <code>run</code> method is invoked by JavaTest to
	 *execute the test defined by this class.
	 *@param args The arguments provided by the test script,
	 *providing configuration information for a test.
	 *@param err A stream to which to report errors.
	 *@param out A stream to report messages.
	 *@return A <code>Status</code> object representing the outcome of the test.
	 */
	public Status run(String[] args, PrintWriter err, PrintWriter out) {

		initializeArgs(args, err, out);


		PersistenceManagerFactory pmf = getPMF();
		pm = pmf.getPersistenceManager();

		testIsActive();
		this.testIsActive();
		pm.close();

		err.flush();
		out.flush();

		int errCnt = getErrorCount();
		if (errCnt == 0)
			return Status.passed("PASSED in IsActive");
		else
			return Status.failed("FAILED in IsActive: number of errors detected is " + errCnt);


	}

}
